SystemOrganization addCategory: #'GT-Spotter-EventRecorder'!

Announcement subclass: #GTSpotterRecorderDataAnnouncement
	instanceVariableNames: 'data imageHash sessionCreationTime timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 15:12'!
data
	^ data! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 15:11'!
data: aByteArray 
	data := aByteArray! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 18:08'!
imageHash
	^ imageHash! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 18:08'!
imageHash: anObject
	imageHash := anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 18:08'!
sessionCreationTime
	^ sessionCreationTime! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 18:08'!
sessionCreationTime: anObject
	sessionCreationTime := anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 18:09'!
timestamp
	^ timestamp! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 18:09'!
timestamp: anObject
	timestamp := anObject! !

Object subclass: #GTSpotterEventRecorder
	instanceVariableNames: 'recordedData mutex proxy process deliveryDelay shouldDeliver'
	classVariableNames: 'SaveDataOnImageQuit'
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

GTSpotterEventRecorder class
	instanceVariableNames: 'instance'!

GTSpotterEventRecorder class
	instanceVariableNames: 'instance'!

!GTSpotterEventRecorder class methodsFor: 'class initialization' stamp: 'AndreiChis 2/25/2015 00:12'!
initialize
	
	Smalltalk 
		addToShutDownList: self! !

!GTSpotterEventRecorder class methodsFor: 'accessing' stamp: 'AndreiChis 2/20/2015 10:36'!
instance

	^ instance ifNil: [ instance := self new ]! !

!GTSpotterEventRecorder class methodsFor: 'accessing' stamp: 'AndreiChis 2/20/2015 10:43'!
reset
	instance := nil! !

!GTSpotterEventRecorder class methodsFor: 'preferences' stamp: 'AndreiChis 2/25/2015 00:22'!
saveDataOnImageQuit

	^ SaveDataOnImageQuit ifNil: [ true ]! !

!GTSpotterEventRecorder class methodsFor: 'preferences' stamp: 'AndreiChis 2/25/2015 00:14'!
saveDataOnImageQuit: aBoolean

	SaveDataOnImageQuit := aBoolean! !

!GTSpotterEventRecorder class methodsFor: 'system startup' stamp: 'JurajKubelka 2/25/2015 12:27'!
shutDown: quitting

	(quitting not or: [self saveDataOnImageQuit not]) ifTrue: [ ^ self ].
	self instance lastDataDelivery.! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/25/2015 18:16'!
announcementFrom: oldRecordedData
	^ GTSpotterRecorderDataAnnouncement new
			data: (self dataAsBinaryStream: oldRecordedData) originalContents;
			timestamp: DateAndTime now;
			imageHash: SmalltalkImage current imageName hash;
			sessionCreationTime: SmalltalkImage current session creationTime;
			yourself! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'JurajKubelka 2/25/2015 11:45'!
dataAsBinaryStream
	^ self dataAsBinaryStream: recordedData! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'JurajKubelka 2/25/2015 18:05'!
dataAsBinaryStream: aRecordedData
	| stream serializer |
	
	stream := ByteArray new writeStream binary.
	serializer := FLSerializer newDefault.
	serializer 
		stream: stream.
	serializer serialize: aRecordedData.
	^ stream! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'AndreiChis 2/24/2015 22:01'!
eventClassNameFor: aSpotterAnnouncementClass

	^  'GTSpotterRecorder', 
		(aSpotterAnnouncementClass name 
			copyFrom: 'GTSpotter' size + 1
			to: aSpotterAnnouncementClass name size), 
		'Event'.
 	
		
! !

!GTSpotterEventRecorder methodsFor: 'initialization' stamp: 'JurajKubelka 2/25/2015 12:03'!
initialize
	super initialize.
	
	recordedData := self newRecordedData.
	proxy := self newProxy.
	mutex := Mutex new.
	self initializeDeliveryProcess.! !

!GTSpotterEventRecorder methodsFor: 'initialization' stamp: 'JurajKubelka 2/25/2015 12:19'!
initializeDeliveryProcess
	process := [ [ self shouldDeliver ] whileTrue: [ 
						self sendChunk.
						deliveryDelay := self standardDuration asDelay.
						deliveryDelay wait.
						deliveryDelay := nil. ] ] 
		forkAt: Processor userBackgroundPriority 
		named: self className, ' regular delivery process'! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/25/2015 18:03'!
initiateDataDelivery
	"To be deleted"
	UIManager default informUserDuring: [ :bar |
  	[ ^ (ZnClient new
			beOneShot;
			timeout: 5;
			signalProgress: true;
			numberOfRetries: 3;
  			retryDelay: 2;
			url: self remoteURL;
			enforceHttpSuccess: true;
			ifFail: [ :exception |   ];
			entity: (ZnByteArrayEntity bytes: self dataAsBinaryStream originalContents);
			put;
			response) ]
    on: HTTPProgress 
    do: [ :progress |  
		progress isEmpty ifFalse: [ bar current: progress percentage ].
      progress resume ] ]
! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/25/2015 18:03'!
lastDataDelivery
	"Maybe we could do nothing. 
	The data can be send next time or never.
	Otherwise I have to wait for sometime. To send it to server.
	Now it is async-operation."
	self sendChunk.! !

!GTSpotterEventRecorder methodsFor: 'initialization' stamp: 'JurajKubelka 2/25/2015 17:51'!
linkToSpotter: aSpotterModel

	aSpotterModel announcer weak when: Announcement send: #recordAccouncement: to: self! !

!GTSpotterEventRecorder methodsFor: 'instance creation' stamp: 'JurajKubelka 2/25/2015 14:47'!
newProxy
	| newProxy |
	newProxy := RAProxy new.
	newProxy url: self remoteURL.
	newProxy useAutoConnection.
	newProxy useRetryStrategy sendEvery: self standardDuration.
	newProxy useSilentBroker.
	^ newProxy! !

!GTSpotterEventRecorder methodsFor: 'instance creation' stamp: 'JurajKubelka 2/25/2015 11:42'!
newRecordedData
	^ OrderedCollection new! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:57'!
proxy
	^ proxy! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'AndreiChis 2/24/2015 22:15'!
recordAccouncement: anAnnouncement
	| recorderEventClassName |

	recorderEventClassName := self eventClassNameFor: anAnnouncement class.
	(Smalltalk hasClassNamed: recorderEventClassName) ifFalse: [ ^ false ].
	
	self storeEvent: (recorderEventClassName asClass fromAnnouncement: anAnnouncement)

	
 	
		
! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'AndreiChis 2/24/2015 21:58'!
recordSpotterOpenEvent

	self storeEvent: GTSpotterRecorderOpenEvent new! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 13:17'!
remoteURL
	^ GTSpotterEventRecorderSettings url! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/25/2015 18:06'!
sendChunk
	| oldRecordedData |
	mutex
		critical: [ 
			recordedData ifEmpty: [ ^ self ].
			oldRecordedData := recordedData.
			recordedData := self newRecordedData ].
	self proxy announce: (self announcementFrom: oldRecordedData)! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 12:18'!
shouldDeliver
	^ shouldDeliver ifNil: [ shouldDeliver := true ]! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 11:55'!
standardDuration
	^ 5 minutes! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/25/2015 12:58'!
stopDelivering
	mutex critical: [ 
		shouldDeliver := false.
		deliveryDelay ifNotNil: [ :aDelay | aDelay delaySemaphore signal ] ]! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'JurajKubelka 2/25/2015 14:59'!
storeEvent: anEvent
	mutex critical: [ 
		recordedData add: anEvent asRecordedData.
		process isTerminated ifTrue: [ self initializeDeliveryProcess ] ]! !

Object subclass: #GTSpotterEventRecorderSettings
	instanceVariableNames: 'uuid url rememberSettings sendUsageData sendSearchQuery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

GTSpotterEventRecorderSettings class
	instanceVariableNames: 'url uniqueInstance'!

GTSpotterEventRecorderSettings class
	instanceVariableNames: 'url uniqueInstance'!

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 2/25/2015 17:31'!
deletePreferences
	"self deletePreferences"
	[ self preferences ensureDelete ]
	on: PrimitiveFailed, FileSystemError do: [ "ignore" ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'reflective operations' stamp: 'JurajKubelka 2/25/2015 14:35'!
doesNotUnderstand: aMessage 
	"delegate all settings to the unique instance"
	^ self uniqueInstance perform: aMessage selector withEnoughArguments: aMessage arguments! !

!GTSpotterEventRecorderSettings class methodsFor: 'class initialization' stamp: 'JurajKubelka 2/25/2015 17:11'!
initialize
	super initialize.
	Smalltalk addToStartUpList: self.
	self loadPreferences.! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 2/25/2015 17:25'!
loadPreferences
	"self loadPreferences"
	self preferences exists ifFalse: [ ^ self savePreferences ].
	[ self preferences readStreamDo: [ :aStream |
			uniqueInstance := STON fromStream: aStream ] ] 
		on: Error, STONReaderError, FileSystemError do: [ "ignore" ] ! !

!GTSpotterEventRecorderSettings class methodsFor: 'origins' stamp: 'JurajKubelka 2/25/2015 13:41'!
preferences
	^ FileLocator preferences / 'org.pharo.gt.spotter.event.recorder.txt' ! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 17:04'!
reset
	"self reset"
	uniqueInstance := nil! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 2/25/2015 17:28'!
savePreferences
	"self savePreferences"
	self deletePreferences.
	[ self preferences writeStreamDo: [ :aStream |
			STON put: self uniqueInstance onStreamPretty: aStream ] ]
		on: STONWriterError, FileSystemError do: [ "ignore" ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'settings' stamp: 'JurajKubelka 2/25/2015 14:37'!
settingsOnSendSearchQuery: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #sendSearchQuery)
		parent: #gt;
		target: self;
		description: 'Spotter: Send search query and selected search results' translated;
		label: 'Spotter: Send search query and selected search results'
! !

!GTSpotterEventRecorderSettings class methodsFor: 'settings' stamp: 'JurajKubelka 2/25/2015 14:27'!
settingsOnSendUsageData: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #sendUsageData)
		parent: #gt;
		target: self;
		description: 'Send basic anonymous usage data.' translated;
		label: 'Send basic anonymous usage data'
! !

!GTSpotterEventRecorderSettings class methodsFor: 'settings' stamp: 'JurajKubelka 2/25/2015 14:38'!
settingsOnUrl: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #stringUrl)
		parent: #gt;
		target: self;
		description: 'The url for the Spotter Event Recorder server.' translated;
		label: 'Spotter Event Recorder URL address'
! !

!GTSpotterEventRecorderSettings class methodsFor: 'system startup' stamp: 'JurajKubelka 2/25/2015 17:10'!
startUp: resuming
	self loadPreferences! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 13:45'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 17:40'!
uuid
	"self uuid"
	^ self uniqueInstance uuid! !

!GTSpotterEventRecorderSettings methodsFor: 'initialization' stamp: 'JurajKubelka 2/25/2015 17:02'!
initialize
	super initialize.
	uuid := UUID new.
	! !

!GTSpotterEventRecorderSettings methodsFor: 'actions' stamp: 'JurajKubelka 2/25/2015 17:37'!
save
	self class savePreferences! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:33'!
sendSearchQuery
	^ sendSearchQuery ifNil: [ sendSearchQuery := false ]! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:42'!
sendSearchQuery: aBoolean
	sendSearchQuery := aBoolean.
	self save.! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:22'!
sendUsageData
	^ sendUsageData ifNil: [ sendUsageData := true ]! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:42'!
sendUsageData: aBoolean
	sendUsageData := aBoolean.
	self save.! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:38'!
stringUrl
	^ self url asString! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:38'!
stringUrl: aUrlString
	^ self url: aUrlString! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 15:32'!
url
	^ url ifNil: [ url := 'ws://gc.dcc.uchile.cl.:80' asZnUrl ]! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 14:42'!
url: aZnUrl
	url := aZnUrl ifNotNil: [ aZnUrl asZnUrl ].
	self save.! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 17:02'!
uuid
	^ uuid! !

Object subclass: #GTSpotterRecorderEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

GTSpotterRecorderEvent subclass: #GTSpotterRecorderActOnEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderActOnEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 1! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderCategorySelectedEvent
	instanceVariableNames: 'categoryLabel elementCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderCategorySelectedEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 3! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:30'!
asRecordedData

	^ self! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:36'!
fromAnnouncement: anAnnouncement

	categoryLabel := anAnnouncement category title.
	elementCount := anAnnouncement category allFilteredCandidates size.! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderDiveInCategoryEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderDiveInCategoryEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 4! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderDiveInElementEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderDiveInElementEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 5! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderDiveOutEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderDiveOutEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 6! !

!GTSpotterRecorderEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	self subclassResponsibility! !

!GTSpotterRecorderEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:08'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTSpotterRecorderEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:52'!
asRecordedData

	^ self "class eventCode"! !

!GTSpotterRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 2/24/2015 21:08'!
fromAnnouncement: anAnnouncement

	! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderExitAnnouncementEvent
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderExitAnnouncementEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 7! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:30'!
asRecordedData

	^ self! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:29'!
initialize
	super initialize.
	
	timestamp := Time now asDateAndTime asUnixTime ! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderHidePreviewEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderHidePreviewEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 8! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderOpenEvent
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderOpenEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 9! !

!GTSpotterRecorderOpenEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:30'!
asRecordedData

	^ self! !

!GTSpotterRecorderOpenEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:29'!
initialize
	super initialize.
	
	timestamp := Time now asDateAndTime asUnixTime ! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderSelectedCandidateChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderSelectedCandidateChangedEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:28'!
eventCode

	^ 2! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderShowPreviewEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder'!

!GTSpotterRecorderShowPreviewEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/24/2015 21:29'!
eventCode

	^ 10! !
GTSpotterEventRecorder initialize!
GTSpotterEventRecorderSettings initialize!
